#!/usr/bin/env python

# Copyright (c) 2018-2019, Swiss Federal Institute of Technology (ETH Zurich)
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
# * Redistributions of source code must retain the above copyright notice, this
#   list of conditions and the following disclaimer.
# 
# * Redistributions in binary form must reproduce the above copyright notice,
#   this list of conditions and the following disclaimer in the documentation
#   and/or other materials provided with the distribution.
# 
# * Neither the name of the copyright holder nor the names of its
#   contributors may be used to endorse or promote products derived from
#   this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

import sys, os, getopt
from struct import *

def usage():
  print( "Usage: flocklab2metric.py <sink address> <serial-input> <powersummary>" )
  print( "" )
  print( "  <sink address>: address of the sink node (so to exclude it from the metric evaluation)" )
  print( "  <serial-input>: serial file generated by FlockLab" )
  print( "  <powersummary>: optional. 'powerprofilingstats.csv' from FlockLab" )

##############################################################################
#
# Main
#
##############################################################################
def main(argv):

  serialfile = None
  powerfile = None
  nodes = [22,2,4,8,15,3,31,32,33,6,16,1,28,18,10]
  
  if len(argv) < 2:
    usage()
    sys.exit()

  serialfile = argv[1]
  inf = open(serialfile, "r")
  
  if len(argv) > 2:
    powerfile = argv[2]
    ppf = open(powerfile, "r")
  
  sinknode = argv[0] # this node is not included in power assesment
  
  sources={}
  line = inf.readline()
  while line != '':
    if line[0]=='#':
      line = inf.readline()
      continue
    try:
      (ts, obs, id, dir, pkt) = line.split(',', 4)
    except ValueError:
      print( line )
      line = inf.readline()
      continue
    if int(obs) == int(sinknode):
      if "Pkt:" in pkt:        
        try:
  	    	(tag, pkt) = pkt.split('Pkt:')
        except ValueError:
          line = inf.readline()
          continue
        try: 
          (src, seq, data) = pkt[0:-1].split(',', 2)
        except ValueError:
          line = inf.readline()
          continue
        src = int(src)
        seq = int(seq)
        data = int(data)
        if src in nodes:
          if not src in sources:
            sources[src] = {}
          sources[src][seq] = data
  
    line = inf.readline()
    
  index = 0
  data_payload={}
  sdf = open("expected_data.lst", "r")
  line = sdf.readline()
  while line != '':
    index = index + 1
    data_payload[index] = int(line)
    line = sdf.readline()
  
  datayield = 0
  for src in sources:
    pk_ok = check_data(src, sources[src], data_payload)
    print( "%d: %d (%d ok) packets" % (src, len(sources[src]), pk_ok) )
    datayield = datayield + pk_ok
    
  datayield = float(datayield) / (len(nodes) * 200.0)
  kpi_datayield = datayield
  print( "Data Yield: %0.2f %% (%0.2f)" % (100 * datayield, kpi_datayield) )
  
  if powerfile is not None:
    sumcurrent = 0.0
    numnodes = 0
    line = ppf.readline()
    while line != '':
      if line[0]=='#':
        line = ppf.readline()
        continue
      (obs, id, current) = line[0:-1].split(',', 3)
      if int(obs) in nodes and int(obs)!=int(sinknode):
        numnodes = numnodes + 1
        sumcurrent = sumcurrent + float(current)
      line = ppf.readline()
    avg_current = sumcurrent / float(numnodes)
    kpi_current = 1 - (avg_current / 25.0)
    print( "Average Current Drain: %0.2f mA (%0.2f)" % (avg_current, kpi_current) )
    print( "Performance Metric: %0.2f" % (kpi_current * 0.5 + kpi_datayield * 0.5) )
  
def check_data(src, pktlist, data_payload):
  pk_ok = 0
  for seq in sorted(pktlist):
    if seq > 200:
      break
    if data_payload[seq] == pktlist[seq]:
      pk_ok = pk_ok + 1
  return pk_ok
  
if __name__ == "__main__":
  main(sys.argv[1:])
